/*************************************************************************
 *
 *  $RCSfile: counter.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: rt $ $Date: 2005/01/31 17:06:40 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  the BSD license.
 *
 *  Copyright (c) 2003 by Sun Microsystems, Inc.
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *  3. Neither the name of Sun Microsystems, Inc. nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 *  OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 *  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 *  TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 *  USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *************************************************************************/

/***************************************************************************************************
 ***************************************************************************************************
 *
 * service implementation:	 iapart.TabBrowse
 * exported interfaces:		 iapart.ITabBrowse
 *
 * task creator service
 *
 ***************************************************************************************************
 **************************************************************************************************/


/*
  01-08-2005
  * Removed most of Andreas' comments
  * Added WindowAttribute::SIZEABLE
  * Added XWindowListener implementation, but without success
  * Tried to add an instance of the TabWindowFactory, without success due to
    compilation problems.
*/
//#include <stdio.h>
//#include <stdio.h>
#include <cstdlib>
#include <list>
#include <rtl/uuid.h>
#ifndef _RTL_USTRING_HXX_
#include <rtl/ustring.hxx>
#endif

#ifndef _CPPUHELPER_QUERYINTERFACE_HXX_
#include <cppuhelper/queryinterface.hxx> // helper for queryInterface() impl
#endif
#ifndef _CPPUHELPER_FACTORY_HXX_
#include <cppuhelper/factory.hxx> // helper for component factory
#endif

#include <cppuhelper/implbase.hxx>
#include <cppuhelper/implbase1.hxx>
#include <cppuhelper/implbase2.hxx>
#include <cppuhelper/implbase3.hxx>
#include <cppuhelper/implbase4.hxx>
#include <cppuhelper/implbase5.hxx>
#include <cppuhelper/implbase6.hxx>
#include <cppuhelper/implbase7.hxx>
//#include <cppuhelper/implbase
// generated c++ interfaces
#ifndef _COM_SUN_STAR_LANG_XSINGLESERVICEFACTORY_HPP_
#include <com/sun/star/lang/XSingleServiceFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XSERVICEINFO_HPP_
#include <com/sun/star/lang/XServiceInfo.hpp>
#endif
#ifndef _COM_SUN_STAR_REGISTRY_XREGISTRYKEY_HPP_
#include <com/sun/star/registry/XRegistryKey.hpp>
#endif
#include <com/sun/star/frame/XDesktop.hpp>
#include <com/sun/star/awt/WindowAttribute.hpp>
#include <com/sun/star/awt/XToolkit.hpp>
#include <com/sun/star/frame/XFrame.hpp>
#include <com/sun/star/awt/WindowDescriptor.hpp>
#include <com/sun/star/awt/XWindowPeer.hpp>
#include <com/sun/star/awt/XWindow.hpp>
#include <com/sun/star/frame/XComponentLoader.hpp>
#include <com/sun/star/frame/XLayoutManager.hpp>
#include <com/sun/star/frame/XFrameActionListener.hpp>
//#include <com/sun/star/frame/
#include <com/sun/star/awt/WindowEvent.hpp>
#include <com/sun/star/awt/XWindowListener.hpp>
#include <com/sun/star/awt/XTopWindowListener.hpp>
//#include <com/sun/star/awt/XTopWindow.hpp>
#include <com/sun/star/awt/XMessageBox.hpp>
#include <com/sun/star/ui/XUIElement.hpp>
#include <com/sun/star/awt/XExtendedToolkit.hpp>
#include <com/sun/star/awt/XMenuBar.hpp>
#include <com/sun/star/util/XCloseListener.hpp>
#include <com/sun/star/util/XCloseBroadcaster.hpp>
#include <com/sun/star/frame/XDispatchHelper.hpp>
#include <com/sun/star/frame/XDispatchProvider.hpp>
#include <com/sun/star/util/XCloseable.hpp>
//#include <com/sun/star/uno/Type.hpp>
//#include <com/sun/star/util/clo
// for the tab control

#include <com/sun/star/lang/XSingleComponentFactory.hpp>
#include <com/sun/star/awt/XSimpleTabController.hpp>
#include <com/sun/star/beans/XPropertySet.hpp>
#include <com/sun/star/awt/XTabListener.hpp>
/* ********************************************************* */

//#include "cTabList.hpp"

/* ********************************************************* */


#define SERVICENAME "iapart.TabBrowse"
#define IMPLNAME	"com.sun.star.comp.apart.cpp.TabBrowse"
#define DEBUG	0

#include <iapart/ITabBrowse.hpp>

namespace css = ::com::sun::star;

using namespace std;
using namespace ::rtl;
using namespace ::osl;
using namespace ::cppu;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::lang;
using namespace ::com::sun::star::registry;
using namespace ::com::sun::star::awt;
using namespace ::com::sun::star::frame;

class cMyWindow;

//===================================================================================

typedef struct
{
       long m_cID;
       Reference< XWindow > m_cWindow;
	Reference< XFrame > m_cFrame;
	Reference< XMenuBar > m_cMenu;
} sChild;
typedef sChild sChildWindow;
//===================================================================================
/* Trick to get an initialized mutex member, which can be used during the ctor too!
*/


struct tLockable
{
    public:
        ::osl::Mutex m_aLock;
};


//===================================================================================

typedef ::cppu::WeakImplHelper1< ::com::sun::star::awt::XTabListener > TabListenerHelper;
class TabListenerImpl : public TabListenerHelper
{
	Reference< XInterface >  m_xParent;
	Reference< ::iapart::ITabBrowse > m_xParentAW;
      public:
		long pActiveID;
        	TabListenerImpl() {};
        	TabListenerImpl(const Reference< XInterface >& xParentInt)
		{
			pActiveID=0;
			m_xParent = xParentInt;
			m_xParentAW = Reference< ::iapart::ITabBrowse >(m_xParent, UNO_QUERY);
			
			if(!m_xParentAW.is())
            ;
            // something went wrong !
		};
		
		
		~TabListenerImpl() 
		{
         // TabListener Destructor has been called
			m_xParent.clear(); 
			m_xParentAW.clear();
		};

        virtual void SAL_CALL disposing (const ::com::sun::star::lang::EventObject& aEObj)
                     throw(::com::sun::star::uno::RuntimeException) 
		{
            // TabListener caught Dispose message
            
			m_xParent.clear();
			m_xParentAW.clear();
                     
		}
        

		virtual void SAL_CALL inserted(long ID)
					throw(::com::sun::star::uno::RuntimeException)
         {
              // A new Tab has been inserted
			  pActiveID = ID;
			  m_xParentAW->showChildWindow(ID);

         }

         virtual void SAL_CALL removed(long ID)
			throw(::com::sun::star::uno::RuntimeException)
		{
			// A Tab has been removed
		}
		
        virtual void SAL_CALL changed(long ID, const Sequence< com::sun::star::beans::NamedValue >& Props)
             throw(::com::sun::star::uno::RuntimeException) 
		{
		
		}
                          
        virtual void SAL_CALL activated(long ID)
			throw(::com::sun::star::uno::RuntimeException)
		{
            // A Tab has been activated
            
 			pActiveID = ID;
            m_xParentAW->showChildWindow(ID);

		}


        virtual void SAL_CALL deactivated(long ID)
			throw(::com::sun::star::uno::RuntimeException)
        {
            // A Tab has been deactivated
                     // unset internal Window ID
                     // m_xMyWin->hideChildWindow(ID);
			 m_xParentAW->hideChildWindow(ID);



        }
      };
// ==========================================================================================

class cMyWindow	: private tLockable,
		 public ::cppu::WeakImplHelper6< ::css::awt::XWindowListener, 
						::css::awt::XTopWindowListener,
//						::css::util::XCloseListener,
						::css::frame::XFrameActionListener,
						XServiceInfo,
						XSingleServiceFactory,
						::iapart::ITabBrowse >
{
	// to obtain other services if needed
	//	oslInterlockedCount m_refcount;
	//	OUString   m_xEventString;
	
	//*************************************************************************
	// FIELD DECLARATIONS
	//*************************************************************************
	
	long m_xActiveID;
	long m_xWidth;
	long m_xHeight;
	

	Reference< XFrameActionListener > m_xFrameActionListener;
	Reference< XTabListener > m_xTabListener;

	Reference< XMultiServiceFactory > m_xServiceManager;

	Reference< XInterface > m_xTabFactory;
	Reference< XSimpleTabController >  m_xTabControl; // { service css::awt::XSimpleTabController };
	Reference< XWindow > m_xTabParentWindow;
   	Reference< XTopWindow > m_xTopWindow;
 
	Reference< XToolkit > m_xToolkit;
	Reference< XDesktop > m_xDesktop;
 
    ::std::list< sChildWindow > m_xChildren; // list of the child windows
    
  public:
  
	//*************************************************************************
	// CONSTRUCTOR & DESTRUCTOR
	//*************************************************************************
	
	cMyWindow* pNew;
	cMyWindow( const Reference< XMultiServiceFactory > & xServiceManager );
	~cMyWindow()
	{
      // cMyWindow class destructor
	}

    
	//*************************************************************************
	// METHOD DECLARATIONS
	//*************************************************************************
	
	
	//*************************************************************************
	// OWN STUFF
	//*************************************************************************
	
	void implLateInit();
    
	
	//*************************************************************************
	// ITabBrowse Interface Implementation
	//*************************************************************************
	
	
	
	virtual void addChildWindow(sChildWindow w); // I don't really know if those methods should be virtual.
    
	//*************************************************************************
	
	virtual Reference< XWindow> findChildWindow(long ID);
	
	//*************************************************************************
	
    virtual void SAL_CALL showChildWindow(long ID) 
		throw(css::uno::RuntimeException);
    
	//*************************************************************************
	
	virtual void SAL_CALL hideChildWindow(long ID) 
		throw(css::uno::RuntimeException);
    
	//*************************************************************************
	
	virtual void SAL_CALL resizeActiveChild(long width, long height) 
		throw(css::uno::RuntimeException);
    
	//*************************************************************************
	
	virtual void SAL_CALL removeChildWindow(long ID)
		throw(css::uno::RuntimeException){};
	
	
	//*************************************************************************
	// XServiceInfo	implementation
	//*************************************************************************
	
    virtual OUString SAL_CALL getImplementationName(  )
			throw(RuntimeException);
			
    virtual sal_Bool SAL_CALL supportsService( const OUString& ServiceName )
			throw(RuntimeException);
			
    virtual Sequence< OUString > SAL_CALL getSupportedServiceNames(  ) 
			throw(RuntimeException);
			
    static Sequence< OUString > SAL_CALL getSupportedServiceNames_Static(  );

    // XSingleServiceFactory implementation needed by the task creator
    virtual Reference< css::uno::XInterface > SAL_CALL createInstance()
        throw(css::uno::Exception,
              css::uno::RuntimeException);

    virtual Reference< css::uno::XInterface > SAL_CALL createInstanceWithArguments(const css::uno::Sequence< css::uno::Any >& lArguments)
        throw(css::uno::Exception,
              css::uno::RuntimeException);
   
    
  
	
	//*************************************************************************
    // DEFINITIONS
	//*************************************************************************
	
	
	//*************************************************************************
	// XWindowListener interface implementation
	//*************************************************************************
	
	virtual void SAL_CALL disposing (const ::com::sun::star::lang::EventObject& e) 
              throw(::com::sun::star::uno::RuntimeException) 
	{
              // XWindowListener interface caught dispose message

				
				if(e.Source == m_xTopWindow) // Top window's close button pressed
				{
                    // The disposing object is a top window
					m_xTopWindow.clear();

				}
				else if(e.Source == m_xTabParentWindow)
				{
                     // The disposing object is a Tab Parent window

					if(m_xDesktop->terminate()) 
					{
						// The desktop has been terminated
							
						Reference< XComponent > xC(m_xTabControl, UNO_QUERY);
						if(xC.is() && m_xTabControl.is())
						{
                           // The tab control hasn't been disposed yet
							xC->dispose();
						    // The tab control dispose message has been sent
						} 

					}

				    ::osl::ResettableMutexGuard aLock(m_aLock);
					m_xTabParentWindow.clear();
					m_xTabListener.clear();
					m_xTabFactory.clear();

					aLock.clear();
				}
				// else - it's probably a childFrame, so find it and close the tab
				else {
					::std::list< sChildWindow >::iterator childListIter;
					for(childListIter = m_xChildren.begin(); 
						childListIter != m_xChildren.end(); 
						childListIter++)
					{
						if(e.Source == (*childListIter).m_cFrame)
						{
							(*childListIter).m_cFrame.clear();
							(*childListIter).m_cWindow.clear();
							(*childListIter).m_cMenu.clear();
									
							try 
							{
								m_xTabControl->removeTab((*childListIter).m_cID);	
							} 
							catch(Exception& e) 
							{
								// one of the tabs has thrown an exception upon removal
							}
							
							m_xChildren.erase(childListIter);
							
							if(m_xChildren.size()==0)
							{
								Reference< XComponent > xC;
								if(m_xTabControl.is())
								{
									xC = Reference< XComponent > (m_xTabControl,UNO_QUERY);
									if(xC.is())
										xC->dispose();
								}
							    
								::osl::ResettableMutexGuard aLock(m_aLock);
								m_xTabListener.clear();
								m_xTabControl.clear();
								m_xTabFactory.clear();
								m_xFrameActionListener.clear();
								aLock.clear();

							}
							break;
						} 						
					}

					if(childListIter==m_xChildren.end())
					{
						// if we got here - I don't know what's being disposed
                                                  					    
						::osl::ResettableMutexGuard aLock(m_aLock);
						m_xTabParentWindow.clear();
						m_xTabListener.clear();
						m_xTabControl.clear();
						m_xTabFactory.clear();
						m_xTopWindow.clear();
						aLock.clear();

					}
				}
	}
	
	//*************************************************************************
	
	virtual void SAL_CALL windowResized(const ::com::sun::star::awt::WindowEvent& e)
            throw(::com::sun::star::uno::RuntimeException)
     {
       // The window has been resized - update the active tab's size
	    m_xWidth = e.Width;
	    m_xHeight = e.Height;
        resizeActiveChild(e.Width, e.Height);         
                     
     }
	 
	//*************************************************************************
	 
	virtual void SAL_CALL windowMoved(const ::com::sun::star::awt::WindowEvent& e)
            throw(::com::sun::star::uno::RuntimeException)
	{
	
	};
	
	//*************************************************************************
	
	virtual void SAL_CALL windowShown(const ::com::sun::star::lang::EventObject& e)
            throw(::com::sun::star::uno::RuntimeException)
	{
            // Window has been shown
	};
	
	//*************************************************************************
	
	virtual void SAL_CALL windowHidden(const ::com::sun::star::lang::EventObject& e)
            throw(::com::sun::star::uno::RuntimeException)
	{
        // Window has been hidden
                	
	};
	
	//*************************************************************************
	// XTopWindowListener Interface implementation
	//*************************************************************************
	
	virtual void SAL_CALL windowOpened(const ::css::lang::EventObject& e) 
			throw(::css::uno::RuntimeException)
	{
       // Top window has been opened
	
	};
	
	//*************************************************************************
	
	virtual void SAL_CALL windowClosing(const ::css::lang::EventObject& e) 
			throw(::css::uno::RuntimeException)
	{
    	// Top window has caught Close message
	};
	
	//*************************************************************************
	
	virtual void SAL_CALL windowClosed(const ::css::lang::EventObject& e) 
			throw(::css::uno::RuntimeException)
	{
       // Top window has been closed
	
	};
	
	//*************************************************************************
	
	virtual void SAL_CALL windowMinimized(const ::css::lang::EventObject& e) 
			throw(::css::uno::RuntimeException)
	{
       // Top window has been minimized
	};
	
	//*************************************************************************
	
	virtual void SAL_CALL windowNormalized(const ::css::lang::EventObject& e) 
			throw(::css::uno::RuntimeException)
	{
        // Top window has been normalized
	
	};
	
	//*************************************************************************
	
	virtual void SAL_CALL windowActivated(const ::css::lang::EventObject& e) 
			throw(::css::uno::RuntimeException)
	{
		// Top window has been activated
	
	};
	
	//*************************************************************************
	
	virtual void SAL_CALL windowDeactivated(const ::css::lang::EventObject& e) 
			throw(::css::uno::RuntimeException)
	{
		// Top window has been deactivated
	
	};

	
	//*************************************************************************
	// XFrameActionListener   interface implementation
	//*************************************************************************
	
	
	virtual void SAL_CALL frameAction(const ::css::frame::FrameActionEvent& e) 
		throw(::css::uno::RuntimeException);
	
	//*************************************************************************
	void closeFrame(Reference< XFrame >& frame);
};

//*************************************************************************

void cMyWindow::closeFrame(Reference< XFrame >& frame)
{
	// The frame is being closed - we have to close the child windows

	::std::list<sChildWindow >::iterator childListIter;
	
	for(childListIter = m_xChildren.begin(); childListIter != m_xChildren.end(); childListIter++)
	{
		
		if((*childListIter).m_cFrame == frame)
		{
			if(!m_xTabControl.is()) 
             ; // The tab control reference is empty !
				
			m_xTabControl->removeTab( (*childListIter).m_cID );

			Reference< ::css::util::XCloseable > xClose(
								(*childListIter).m_cFrame,
								UNO_QUERY
								);
			
			if(xClose.is())
			{
				// Retrieved XCLOSEABLE interface of the child -> CLOSING it!
				xClose->close((sal_Bool) true);			
			}
		    
			
			// set mutex guard
			::osl::ResettableMutexGuard aLock(m_aLock);
			
				Reference< XComponent > xC(
								(*childListIter).m_cFrame,
								UNO_QUERY
								);
								
				(*childListIter).m_cWindow.clear();
			
				//if((*childListIter).m_cWindow.is()) 
                // The reference couldn't be cleared - maybe do something with it
			
				(*childListIter).m_cFrame.clear();
			
				//if((*childListIter).m_cWindow.is() && DEBUG) 
				// The reference couldn't be cleared - maybe do something with it
				
				(*childListIter).m_cMenu.clear();
			
				m_xChildren.erase(childListIter);
			
			aLock.clear();
			// clear mutex guard
					
			break;
		}


	}	

}

//*************************************************************************

void SAL_CALL cMyWindow::frameAction(const ::css::frame::FrameActionEvent& e) 
	throw(::css::uno::RuntimeException)
{
	// A Frame Action event has been fired
	
	Reference< XFrame > xFrame(e.Frame);

	if(e.Action == 0)
	{
       // It's an COMPONENT_ATTACHED event
			
		Reference< css::beans::XPropertySet > xFrameProp(
												xFrame, 
												UNO_QUERY_THROW);
							
		Reference< XLayoutManager > xLayout;
		Any aProp = xFrameProp->getPropertyValue(::rtl::OUString::createFromAscii("LayoutManager"));
		aProp >>= xLayout;
		
		//if(!xLayout.is()) 
		//	We couldn't retrieve the XLayoutManager interface - not good
		
		
		Reference< css::ui::XUIElement > xMenu (
											xLayout->getElement(
													::rtl::OUString::createFromAscii("private:resource/menubar/menubar")
													)
												);
		if(! xMenu.is()) 
		{
             // couldn't retrieve the XMenu interface
             // try to create the menubar - maybe it's not there

			
			xLayout->createElement(
									::rtl::OUString::createFromAscii( "private:resource/menubar/menubar" )
									);
									
			xMenu = Reference<css::ui::XUIElement > (
									xLayout->getElement(
											::rtl::OUString::createFromAscii("private:resource/menubar/menubar")
											)
										);
										
			//if(!xMenu.is()) 
			//	still no XMenu :(

		}
				
			if(xMenu.is()) 
			{
				
				Reference< css::beans::XPropertySet > xUIElProps (
														xMenu, 
														UNO_QUERY
														);
														
				Reference< XMenuBar > menuBar;
				aProp = xUIElProps->getPropertyValue(
										::rtl::OUString::createFromAscii("XMenuBar")
										);
				aProp >>=menuBar;
				
				if(menuBar.is())
				{
					// XMenuBar interface retrieved properly
		        	   
					::std::list< sChildWindow >::iterator childListIter;
					
			        for(childListIter = m_xChildren.begin(); 
						childListIter != m_xChildren.end(); 
						childListIter++)
			           {
			
							if( (*childListIter).m_cFrame  == xFrame)
							{
								aProp >>=(*childListIter).m_cMenu;
								
								//if(!(*childListIter).m_cMenu.is() && DEBUG)
								// couldn't initiate child wth xMenu 
								
								break;
							}
			           }

				}
			}	
			
		} else if(e.Action == 1)
		{
			// COMPONENT_DETACHING
			// find the Tab and clear it's m_cMenu
		
		}
		else if(e.Action ==2)
		{
    
			// COMPONENT_REATACHING 
			// update the tab's m_cMenu
		}
		else if(e.Action ==4)
		{
            // FRAME_DEACTIVATING
		}
	}



//*************************************************************************

cMyWindow::cMyWindow( const Reference< XMultiServiceFactory > & xServiceManager )
		: m_xServiceManager( xServiceManager ) 
{
    // The constructor

		
	if ( ! m_xServiceManager.is() )
        throw css::uno::RuntimeException(
                ::rtl::OUString::createFromAscii("Cant live without an UNO Service manager."),
                static_cast< css::lang::XSingleServiceFactory* >(this));


	m_xActiveID = -1;
	m_xWidth=0;
	m_xHeight=0;

	m_xDesktop = Reference< XDesktop >(m_xServiceManager->createInstance(
		                OUString(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.frame.Desktop"))), 
						UNO_QUERY_THROW
						);

	m_xToolkit = Reference< XToolkit >(m_xServiceManager->createInstance(
						OUString(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.awt.Toolkit"))),
						UNO_QUERY_THROW
						);
 
	m_xTabFactory = Reference< XInterface > (m_xServiceManager->createInstance(
                        ::rtl::OUString::createFromAscii("com.sun.star.frame.TabWindowFactory")),
						UNO_QUERY_THROW
						); 
						
	Reference< XMultiServiceFactory > xMgr = m_xServiceManager;                             
	Reference< ::com::sun::star::beans::XPropertySet > xProps(
														xMgr, 
														UNO_QUERY_THROW
														);
	
	Any aProp = xProps->getPropertyValue(::rtl::OUString::createFromAscii("DefaultContext"));
	Reference< XComponentContext > xDefaultContext;
    
	aProp >>= xDefaultContext;  // I like this. It's really slick.
    
	Reference< XSingleComponentFactory > xTabCompFactory (
											m_xTabFactory, 
											UNO_QUERY_THROW
											);
											
	Reference< XInterface > xTabControl = xTabCompFactory->createInstanceWithContext(xDefaultContext);
	m_xTabControl = Reference< XSimpleTabController > (
											xTabControl, 
											UNO_QUERY_THROW);
											
   // end of the constructor
}

//*************************************************************************

Reference< css::uno::XInterface > SAL_CALL cMyWindow::createInstance()
    throw(css::uno::Exception,
          css::uno::RuntimeException)
{
    return createInstanceWithArguments(css::uno::Sequence< css::uno::Any >());
}

//*************************************************************************

Reference< css::uno::XInterface > SAL_CALL cMyWindow::createInstanceWithArguments(const css::uno::Sequence< css::uno::Any >& lArguments)
    throw(css::uno::Exception       ,
          css::uno::RuntimeException)
{

	try
    {

        // That's why this rule: unlock your mutex everytime you call out !!! .-))

        ::osl::ResettableMutexGuard aLock(m_aLock);
        
			Reference< css::lang::XMultiServiceFactory > xFact    = m_xServiceManager;
            Reference< css::frame::XFramesSupplier >     xDesktop (
															m_xDesktop, 
															css::uno::UNO_QUERY_THROW
															);
      
        aLock.clear();

        // Creation of services and querying interfaces can be combined.
		
	    Reference< css::frame::XFrames > xContainer = xDesktop->getFrames();
		Reference< css::awt::XToolkit > xTk(
								xFact->createInstance(::rtl::OUString::createFromAscii("com.sun.star.awt.Toolkit")),
								css::uno::UNO_QUERY_THROW
								);

        
	

        css::awt::WindowDescriptor wDesc;
        wDesc.Type              = WindowClass_SIMPLE;
        wDesc.WindowServiceName = OUString(RTL_CONSTASCII_USTRINGPARAM(""));
        wDesc.ParentIndex       = 0;
        wDesc.Parent            = Reference< XWindowPeer > ( 
										m_xTabParentWindow, 
										UNO_QUERY_THROW
										);
															
        wDesc.Bounds            = (Reference< XWindow >(wDesc.Parent,UNO_QUERY_THROW))->getPosSize();
        wDesc.WindowAttributes  = WindowAttribute::CLOSEABLE;
//                                  WindowAttribute::SIZEABLE; //  | WindowAttribute::SHOW; dont show windows on creation time! It has to be done later explicitly.

		Reference< css::frame::XFrame > xFrameChild(
										xFact->createInstance(OUString(RTL_CONSTASCII_USTRINGPARAM("com.sun.star.frame.Frame"))), 
										UNO_QUERY_THROW
										);
												
        Reference< css::awt::XWindowPeer > xPeerChild = xTk->createWindow(wDesc);
        Reference< css::awt::XWindow >     xWindow1(
											xPeerChild, 
											UNO_QUERY_THROW);
	

		xFrameChild->setName(	::rtl::OUString::createFromAscii("my window") + 
								::rtl::OUString::valueOf((sal_Int32)m_xChildren.size()));
	
	xFrameChild->initialize(xWindow1);



	xFrameChild->addFrameActionListener(
				Reference< XFrameActionListener > (
								static_cast<XSingleServiceFactory *> (this),
								UNO_QUERY
								)
				);

    xWindow1->setVisible((sal_Bool)true);

	xContainer->append(xFrameChild);
	xFrameChild->setCreator(xDesktop);

	
    long t1ID = m_xTabControl->insertTab();
                
    sChildWindow xChildWindow;
        
    xChildWindow.m_cID = t1ID;
	xChildWindow.m_cFrame = xFrameChild;
    xChildWindow.m_cWindow = xWindow1;
	
    addChildWindow(xChildWindow);
       
    Sequence< css::beans::NamedValue > props(1);
        
	
    props[0].Name = ::rtl::OUString::createFromAscii("Title");
    props[0].Value= makeAny(xFrameChild->getName());
    m_xTabControl->setTabProps(t1ID, props);
	m_xTabControl->activateTab(t1ID);
	
    return Reference< css::uno::XInterface >(
							xFrameChild, 
							css::uno::UNO_QUERY_THROW
							);


    }
    catch(const css::uno::RuntimeException& exRuntime)
    {
        throw exRuntime;
    }
    catch(const css::uno::Exception& exAny)
	{
        // This is a place where we can deal with the exception we've caught
        // One way is to print out the error string like this:
		//   OString s = OUStringToOString(
		//						exAny.Message, 
		//						RTL_TEXTENCODING_ASCII_US
		//						);
        //    fprintf(stderr, "Error: %s\n", s.pData->buffer);
		// But it's really only for debug.
	}
    return Reference< css::uno::XInterface >();
}

//*************************************************************************

void cMyWindow::addChildWindow(sChildWindow xChildWindow)
{
    m_xChildren.push_back(xChildWindow);
	m_xActiveID = xChildWindow.m_cID;
 }

//*************************************************************************

Reference< XWindow > cMyWindow::findChildWindow(long ID)
		// throw(IndexOutOfBoundException) <- whatever the name is, throw it if the ID is not found in the list
{

           ::std::list< sChildWindow >::const_iterator childListIter;
           for(childListIter = m_xChildren.begin(); 
				childListIter != m_xChildren.end(); 
				childListIter++)
           {
	
                   if((*childListIter).m_cID == ID )
                      return (*childListIter).m_cWindow;
           }
		// else throw the exception
   return NULL;
}

//*************************************************************************

void SAL_CALL cMyWindow::hideChildWindow(long ID)
		throw(css::uno::RuntimeException)
{
    Reference< XWindow > xChildWindow = findChildWindow(ID);
	if(xChildWindow!=NULL) 
		xChildWindow->setVisible((sal_Bool)false);
 }
 
//*************************************************************************

void SAL_CALL cMyWindow::showChildWindow(long ID)
		throw(css::uno::RuntimeException)
{

		
	//sChildWindow* xChildWindow = NULL;


    ::std::list< sChildWindow >::const_iterator childListIter;
    for(childListIter = m_xChildren.begin(); 
		childListIter != m_xChildren.end(); 
		childListIter++)
    {
        if((*childListIter).m_cID == ID )
		{	
			// found it !
			
			childListIter;
			m_xActiveID = ID;
			resizeActiveChild(m_xWidth, m_xHeight);
			
			// set it to visible !
			((*childListIter).m_cWindow)->setVisible((sal_Bool)true);

			if(((*childListIter).m_cMenu).is())
			{
					
				if(m_xTopWindow.is())
				{
					
					// TopWindow->setMenuBar bug - commented out
					// due to a bug in xTopWin implementation
					//			xTopWin->setMenuBar(((*childListIter).m_cMenu));
				}	
			} 
		}
	}

 }

//*************************************************************************

void SAL_CALL cMyWindow::resizeActiveChild(long width, long height)
		throw(css::uno::RuntimeException)
{
	if(m_xActiveID != -1) {
				
		// 3 flags POS
		// 12 flags only the size of the window.
		// 15 flags both - POS | SIZE
		
		Reference< XWindow > child = findChildWindow(m_xActiveID);
		if(child!=NULL) 
			child->setPosSize(0,0,width,height,15); 
	}

} 

//*************************************************************************

OUString SAL_CALL cMyWindow::getImplementationName(  )
		throw(RuntimeException)
{
	return OUString( RTL_CONSTASCII_USTRINGPARAM(IMPLNAME) );
}

//*************************************************************************

sal_Bool SAL_CALL cMyWindow::supportsService( const OUString& ServiceName )
		throw(RuntimeException)
{
	Sequence< OUString > aSNL = getSupportedServiceNames();
	
	const OUString * pArray = aSNL.getArray();
	for( sal_Int32 i = 0; i < aSNL.getLength(); i++ )
		if( pArray[i] == ServiceName )
			return sal_True;
	
	return sal_False;
}

//*************************************************************************

Sequence<OUString> SAL_CALL cMyWindow::getSupportedServiceNames(  )
		throw(RuntimeException)
{
	return getSupportedServiceNames_Static();
}

//*************************************************************************

Sequence<OUString> SAL_CALL cMyWindow::getSupportedServiceNames_Static(  )
{
	OUString aName( RTL_CONSTASCII_USTRINGPARAM(SERVICENAME) );
	return Sequence< OUString >( &aName, 1 );
}



//*************************************************************************
/**
 * Function to create a new component instance; is needed by factory helper implementation.
 * @param xMgr service manager to if the components needs other component instances
 */
Reference< XInterface > SAL_CALL cMyWindow_create(
	const Reference< XMultiServiceFactory > & xMgr )
{
		
	cMyWindow* pNew = new cMyWindow(xMgr);
	pNew->implLateInit();

	return Reference<XInterface>(static_cast< XSingleServiceFactory* >(pNew));
}

//*************************************************************************

void cMyWindow::implLateInit()
{		
	
	Reference< XInterface > xThis(static_cast< XSingleServiceFactory* >(this), UNO_QUERY);
	Reference< XWindowListener > xWL(xThis, UNO_QUERY);
	
	// if(!xWL.is()) 
	// we haven't received an XWindowListener interface, which isn't good

	TabListenerImpl* xTabListenerImpl = new ::TabListenerImpl(xThis);
	m_xTabListener = static_cast< XTabListener *> (xTabListenerImpl);
        
	m_xTabControl->addTabListener(m_xTabListener);

    Reference< css::beans::XPropertySet > xTabProp(m_xTabControl, UNO_QUERY_THROW);
    Any aTabProp = xTabProp->getPropertyValue(::rtl::OUString::createFromAscii("ParentWindow"));

    aTabProp >>= m_xTabParentWindow;
	aTabProp = xTabProp->getPropertyValue(::rtl::OUString::createFromAscii("TopWindow"));
	aTabProp >>= m_xTopWindow;

	m_xTopWindow->addTopWindowListener(Reference< XTopWindowListener >(xThis, UNO_QUERY));
	m_xTabParentWindow->addWindowListener(xWL);

}
//##################################################################################################
//#### EXPORTED ####################################################################################
//##################################################################################################


/**
 * Gives the environment this component belongs to.
 */
extern "C" void SAL_CALL component_getImplementationEnvironment(const sal_Char ** ppEnvTypeName, uno_Environment ** ppEnv)
{
	*ppEnvTypeName = CPPU_CURRENT_LANGUAGE_BINDING_NAME;
}

/**
 * This function creates an implementation section in the registry and another subkey
 *
 * for each supported service.
 * @param pServiceManager   the service manager
 * @param pRegistryKey      the registry key
 */
extern "C" sal_Bool SAL_CALL component_writeInfo(void * pServiceManager, void * pRegistryKey)
{
	sal_Bool result = sal_False;

	if (pRegistryKey)
	{
		try
		{
			Reference< XRegistryKey > xNewKey(
				reinterpret_cast< XRegistryKey * >( pRegistryKey )->createKey(
					OUString( RTL_CONSTASCII_USTRINGPARAM("/" IMPLNAME "/UNO/SERVICES") ) ) );

			const Sequence< OUString > & rSNL =
				cMyWindow::getSupportedServiceNames_Static();
			const OUString * pArray = rSNL.getConstArray();
			for ( sal_Int32 nPos = rSNL.getLength(); nPos--; )
				xNewKey->createKey( pArray[nPos] );

			return sal_True;
		}
		catch (InvalidRegistryException &)
		{
			// we should not ignore exceptions
		}
	}
	return result;
}

/**
 * This function is called to get service factories for an implementation.
 *
 * @param pImplName       name of implementation
 * @param pServiceManager a service manager, need for component creation
 * @param pRegistryKey    the registry key for this component, need for persistent data
 * @return a component factory
 */
extern "C" void * SAL_CALL component_getFactory(const sal_Char * pImplName, void * pServiceManager, void * pRegistryKey)
{
	void * pRet = 0;
		
		
	if (rtl_str_compare( pImplName, IMPLNAME ) == 0)
	{
		Reference< XSingleServiceFactory > xFactory( createOneInstanceFactory(
			reinterpret_cast< XMultiServiceFactory * >( pServiceManager ),
			OUString( RTL_CONSTASCII_USTRINGPARAM(IMPLNAME) ),
			cMyWindow_create,
			cMyWindow::getSupportedServiceNames_Static() ) );

		if (xFactory.is())
		{
			xFactory->acquire();
			pRet = xFactory.get();
		}
	}

		
	return pRet;
}
